## CERN-HSF GSoC 2020
### _Health Checks and Monitoring Dashboard for ScienceBox_
-----

This repository contains the exercises to evaluate students interested in applying for the project _"Health Checks and Monitoring Dashboard for ScienceBox"_, which is part of the [Google Summer of Code (GSoC)](https://summerofcode.withgoogle.com/) program 2020 and is proposed by the [Information Technology Department](http://information-technology.web.cern.ch/) of [CERN](https://home.cern).

The detailed description of the project can be found at https://hepsoftwarefoundation.org/gsoc/2020/proposal_ScienceBoxMonitor.html

Please follow the guidelines below to go through the exercise. 

&nbsp;

### Exercise for Candidate Students
-----
We recommend you start with the first task and, only if you successfully complete it, proceed to the following ones.
Once you complete any of the tasks of the exercise, send back to the mentors the requested deliverables via email.

Do not hesitate to contact the mentors if you have questions or need clarifications on the exercise.
If you find difficulties in carrying out the required tasks or get blocked, please provide the following details:
  * What are you unable to achieve
  * Which is, in your opinion, the root cause of the problem and why
  * What is the status of your system (hardware setup, software versions, etc.)
  * What would be the expected outcome
  * What is the actual outcome
  * Any other information you think is relevant

In the following tasks, you are asked to use different technologies: 
  * [Docker](https://www.docker.com/)
  * [Kubernetes](https://kubernetes.io/)
  * [Bash](https://www.gnu.org/software/bash/)
  * [Python](https://www.python.org/)


##### _Task 1_
Write a docker-compose file called `webserver.yaml` so that:
* One container runs a web server of your choice (Apache httpd, nginx, ...) with a simple hello world // default landing page
* It is periodically verified that the web server is up and serves requests as expected
* A second container reads the traffic logs generated by the web server and displays them on the standard output

It is encouraged to use upstream images available on [DockerHub](https://hub.docker.com/) for the web server.
If customizations are required, re-use the upstream images as much as possible.

_Deliverables:_
1. The docker-compose `webserver.yaml
2. The Dockerfiles for the additional images (if applicable)
3. The output of relevant Docker commands to demonstrate the containers are running as expected


#### _Task 2_
Install [ScienceBox](https://sciencebox.web.cern.ch/) on your system using the docker-compose version.
You will need at least 50GB of free space on your local disk. Installations on VMs is also supported.
Ubuntu and CentOS are the supported operating systems. We are happy to hear about successful deployments on other OSes.

_Deliverables:_
1. A screenshot of the welcome page of ScienceBox running on your system
2. The output of the installation script and the Docker logs


#### _Task 3_
Write a simple Python program called `help_robinson.py` which:
* Downloads the text of "The Life and Adventures of Robinson Crusoe" by Daniel Defoe ([fulltext](http://www.gutenberg.org/files/521/521-0.txt))
* Counts the words "island" and "islands" (case-insensitive)
* Writes the results into a simple text file `islands.txt` in the format: `<word> <count>`

_Deliverables:_
1. The Python program `help_robinson.py`
2. The output file with the count results `islands.txt`


##### _Task 4 -- Bonus_
Redo _Task 1_ using [MiniKube](https://kubernetes.io/docs/tasks/tools/install-minikube/) and port the `webserver.yaml` to `webserver_k8s.yaml` file compatible with the Kubernetes APIs.

_Deliverables:_
1. A script that automates the installation of MiniKube to reproduce your setup
2. The `webserver_k8s.yaml` file with the description of the required resources
3. Relevant Kubernetes logs to demonstrate the deployment works as expected


#### _Task 5 Grafana Graphite -- Super Bonus_
Complement the docker-compose yaml file of _Task 1_ with the necessary set of containers to run a [Grafana](https://grafana.com/) instance for data visualization.
Automate the ingestion of the web server logs to the Grafana instance and create a dashboard on the like (e.g., number of requests per second, size of the requests, ...).

_Deliverables:_
1. The modified `webserver.yaml` file with the additional containers
2. The script (if needed) and a description of the required modification to have the web server metrics pushed to Grafana
3. A screenshot of the dashboard you have created

&nbsp;

### Deliverables
-----
Once you complete any of the tasks of this exercise, please send the requested deliverable to:
  * enrico.bocchi@cern.ch
  * diogo.castro@cern.ch

